<template>
  <q-page class="q-pa-md row items-start q-gutter-md">

    <q-card class="my-card">
      <q-card-section>
        Development Environment Main Page ( {{getProjName}} )
      </q-card-section>
    </q-card>

    <q-card class="my-card">
      <q-card-section>
        Status: {{getProjState}}
      </q-card-section>
    </q-card>

    <q-card class="my-card">
      <q-card-section>
        <q-btn outline style="color: goldenrod;" label="Stop Project" @click="stopProj(getProjName)" />
      </q-card-section>
    </q-card>

    <q-card class="my-card">
      <q-card-section>
        <q-btn style="background: goldenrod; color: white" label="Start Project" @click="startProj(getProjName)" />
      </q-card-section>
    </q-card>

    <q-card class="my-card">
      <q-card-section>
        Terminal: ssh devs1@{{getBeDomain}} -p {{getProjSshPort}} 
      </q-card-section>
    </q-card>

    <q-card class="my-card">
      <q-card-section>
        Source Code: ssh devs1@{{getBeDomain}} -p {{getProjSshFolderPort}} 
      </q-card-section>
    </q-card>

    <q-card bordered class="my-card">

      <q-list dense bordered padding class="rounded-borders">
        <q-item v-ripple>
          <q-item-label overline>Setup a new Quasar project</q-item-label>
        </q-item>

        <q-item v-ripple>
          <q-item-section>1) cd /app/</q-item-section>
        </q-item>

        <q-item v-ripple>
          <q-item-section>2) quasar create yourProj</q-item-section>
        </q-item>

        <q-item v-ripple>
          <q-item-section>3) cd /app/yourProj</q-item-section>
        </q-item>

        <q-item v-ripple>
          <q-item-section>
            <q-item-label>4) vi quasar.conf.js</q-item-label>
            <q-item-label caption>
              <pre>
                  <code>
...
var fs = require('fs');
...
devServer: {
  https: true
  , key: fs.readFileSync('/etc/ssl/domain.key')
  , cert: fs.readFileSync('/etc/ssl/domain.crt')
  , port: {{getProjWebPort}}
  , open: false
},          
...
                  </code>
              </pre>
            </q-item-label>
          </q-item-section>          
        </q-item>

        <q-item v-ripple>
          <q-item-section>5) quasar dev</q-item-section>
        </q-item>

        <q-item v-ripple>
          <q-btn type="a" :href="getBeWeb" target="_blank" :label="getBeWeb + ' at your browser'" push color="purple" />
        </q-item>

      </q-list>
    </q-card>

    <q-card bordered class="my-card">
      <q-list dense bordered padding class="rounded-borders">

        <q-item v-ripple>
          <img
            src="/VCode-Sftp.png"
            style="max-width: 600px"
          >
          </img>
        </q-item>

        <q-item v-ripple>
          <q-item-section>Setup Visual Studio Code at your desktop</q-item-section>
        </q-item>

        <q-item v-ripple>
          <img
            src="/sftpSetting.png"
            style="max-width: 600px"
          >
          </img>
        </q-item>

        <q-item v-ripple>
          <q-item-section>
            <q-item-label>Sftp Setting eg. -- same to above "Source Code: ssh"</q-item-label>
            <q-item-label caption>
              <pre>
                  <code>
{
    "name": "your_created_project_name",
    "host": "sfdev.ckl.hk",
    "protocol": "sftp",
    "port": 18001,
    "username": "devs1",
    "remotePath": "/app/your_created_project_name",
    "uploadOnSave": true
    , "ignore": [
        "\\.vscode",
        "\\.git",
        "\\.DS_Store"
        ,"\\node_modules"
    ]
}
                  </code>
              </pre>
            </q-item-label>
          </q-item-section>          
        </q-item>
      </q-list>
    </q-card>

    <q-card bordered class="my-card">
      <q-list dense bordered padding class="rounded-borders">

        <q-item v-ripple>
          <q-item-section>
            <q-item-label>Make sure the OAuth2 Servers: eg, Google, Facebook, with this domain allowed / re-directed</q-item-label>
          </q-item-section>
        </q-item>

        <q-item v-ripple>
          <q-btn type="a" href="https://console.developers.google.com" target="_blank" label="goto console.developers.google.com" push color="purple" />
        </q-item>

        <q-item v-ripple>
          <q-item-section>
            <q-item-label caption>
              <pre>
                  <code>
- your user, eg. devs1.sf@gmail.com
    - Configure a project
        - Product name: your Project Name, eg. "Shi Fang Dev / shi-fang-dev"
          - Credentials > OAuth 2.0 Client IDs 
                - OAuth client: Web Browser
                    - Authorized Javascript Origin: 
                        - https://{{getBeDomain}}:{{getProjWebPort}}
                - Web client (Auto-created for Google Sign-in)
                    - Authorized Javascript Origin: 
                        - https://{{getBeDomain}}:{{getProjWebPort}}
                    - Authorized redirect URIs
                        - https://{{getBeDomain}}:{{getProjWebPort}}
                  </code>
              </pre>
            </q-item-label>
          </q-item-section>

        </q-item>

      </q-list>
    </q-card>

    <q-card bordered class="my-card">
      <q-list dense bordered padding class="rounded-borders">

        <q-item v-ripple>
          <q-item-section>
            <q-item-label>Make sure this Frappe Dev CORS setup with this frontend domain</q-item-label>
            <q-item-label>nano @{{getBeDomain}}:/data/mergerFS/virt/rvs-prxy/traefik/apps/zzthis/traefik_conf.d/traefik_dyn.toml</q-item-label>
            <q-item-label caption>
              <pre>
                  <code>
[http.middlewares]
  [http.middlewares.redirect-to-www.redirectRegex]
    ...
    [http.middlewares.cors-headers.headers]
    accessControlAllowHeaders = ["Origin", "Authorization", "Content-Type". "SfAuth"]
    accessControlAllowMethods = ["GET", "OPTIONS", "PUT", "POST", "PATCH"]
    accessControlAllowOriginList = [..., "https://{{getBeDomain}}:{{getProjWebPort}}"]
    accessControlMaxAge = 100
    addVaryHeader = true
                  </code>
              </pre>
            </q-item-label>
          </q-item-section>
        </q-item>

      </q-list>
    </q-card>

    <q-card class="my-card">
      <q-card-section>
        <q-btn color="deep-orange" glossy label="Del This Project" @click="confirmDelProj = true" />
      </q-card-section>
    </q-card>

    <q-dialog v-model="confirmDelProj">
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar icon="signal_wifi_off" color="primary" text-color="white" />
          <span class="q-ml-sm">Are you sure you want to REMOVE this Project ( {{getProjName}} ) ?</span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
          <q-btn flat label="YES, Please Remove it." color="primary" @click="confirmDelProj2 = true" />

          <q-dialog v-model="confirmDelProj2">
            <q-card>
              <q-card-section>
                <div class="text-h6">PLEASE ATTENTION !! Removing this Project will delete all your workspace codes.</div>
              </q-card-section>
              <q-card-section class="row items-center q-gutter-sm">
                <q-btn v-close-popup="2" label="CANCEL removing this Project." color="secondary" />
                <q-btn v-close-popup="2" label="CONFIRM to DELETE all the codes." color="red" @click="delProj(getProjName)"/>
              </q-card-section>
            </q-card>
          </q-dialog>

        </q-card-actions>
      </q-card>
    </q-dialog>

  </q-page>

</template>

<script>

// call to a msg dialog box
import { newMsgDiag } from 'src/utils/dialogs/dialogCreate'
import MsgDiaglog from "src/utils/dialogs/MsgDialog.vue"

export default {
  name: 'DevEnv1',

  data () {
    return {
      confirmDelProj: false
      , confirmDelProj2: false
    }
  },

  /*watch: {
    loginFlag: function (val, oldVal) {
      console.log('loginFlag: new: %s, old: %s', val, oldVal)
      console.log('loginFlag: ', val)

    },
     
  },*/

  computed: {

    getProjName () {
      return this.$store.state.gen.proj.name
    },

    getProjState() {
      return this.$store.state.gen.selProjState
    },
    
    getProjSshPort() {
      return this.$store.state.gen.proj.sshport
    },
    
    getProjSshFolderPort() {
      return this.$store.state.gen.proj.sshdFolderPort
    },
    
    getProjWebPort() {
      return this.$store.state.gen.proj.webport
    },
    
    getBeDomain() {
      return process.env.BACKEND_DOMAIN
    },
    
    getBeWeb() {
      return process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + ":" + this.$store.state.gen.proj.webport
    },
    
  },

  methods: {

    startProj(projName) {
      var that = this;
      //console.log("del this proj ", projName);

      // creating quasar dev. env.
      this.$axios({
        url: 'gnl.gnl.doctype.devenv.devenv.stProj',
        method: 'post',
        baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
        data: {
          "user_id": this.$store.state.gen.userInfo.user_id
          , "prj_name": projName
        },
        headers: { SfAuth: this.$store.state.gen.userInfo.token },
      })
      .then(function (response) {

        switch (response.status) {
            case 200:
                if (response.data == "{}") {
                    console.log('Creating Qusar: empty response data'); 
                } else {
                    var ret = JSON.parse(response.data.message);

                    if (ret.status == "Done") {
                      that.$store.commit('gen/updateSelProjState', true);

                    } else if (ret.status == "InAuth") {
                        //console.log("ret.des ", ret.des);
                        newMsgDiag(MsgDiaglog, "Please Logout, then Login again.");
                    } else if (ret.status == "InData") {
                        console.log(ret.des);
                    } else if (ret.status == "InFs") {
                        newMsgDiag(MsgDiaglog, ret.des);
                    } else 
                        console.log('listProj: A err. of null of above'); 
                }
            break;
            default:
                //console.log("Misc. Err. in creating ", xhr);
                //callback("Misc. Err. in creating ");
        }
      })
      .catch(function (err) {
        newMsgDiag(MsgDiaglog, '** Server Err. at delProj: please contact Administrator; ' + err);
      });

    },
    
    stopProj(projName) {
      var that = this;
      //console.log("del this proj ", projName);

      // creating quasar dev. env.
      this.$axios({
        url: 'gnl.gnl.doctype.devenv.devenv.stopProj',
        method: 'post',
        baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
        data: {
          "user_id": this.$store.state.gen.userInfo.user_id
          , "prj_name": projName
        },
        headers: { SfAuth: this.$store.state.gen.userInfo.token },
      })
      .then(function (response) {

        //console.log('delProj response ', response);
        switch (response.status) {
            case 200:
                if (response.data == "{}") {
                    console.log('Creating Qusar: empty response data'); 
                } else {
                    var ret = JSON.parse(response.data.message);

                    if (ret.status == "Done") {
                      that.$store.commit('gen/updateSelProjState', false);
                      
                    } else if (ret.status == "InAuth") {
                        //console.log("ret.des ", ret.des);
                        newMsgDiag(MsgDiaglog, "Please Logout, then Login again.");
                    } else if (ret.status == "InData") {
                        console.log(ret.des);
                    } else if (ret.status == "InFs") {
                        newMsgDiag(MsgDiaglog, ret.des);
                    } else 
                        console.log('listProj: A err. of null of above'); 
                }
            break;
            default:
                //console.log("Misc. Err. in creating ", xhr);
                //callback("Misc. Err. in creating ");
        }
      })
      .catch(function (err) {
        newMsgDiag(MsgDiaglog, '** Server Err. at delProj: please contact Administrator; ' + err);
      });

    },
    
    delProj (projName) {
      var that = this;
      //console.log("del this proj ", projName);

      // creating quasar dev. env.
      this.$axios({
        url: 'gnl.gnl.doctype.devenv.devenv.delProj',
        method: 'post',
        baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
        data: {
          "user_id": this.$store.state.gen.userInfo.user_id
          , "prj_name": projName
          , "soln": this.$store.state.gen.proj.soln
        },
        headers: { SfAuth: this.$store.state.gen.userInfo.token },
      })
      .then(function (response) {

        //console.log('delProj response ', response);
        switch (response.status) {
            case 200:
                if (response.data == "{}") {
                    console.log('Creating Qusar: empty response data'); 
                } else {
                    var ret = JSON.parse(response.data.message);

                    if (ret.status == "Done") {
                      that.$store.commit('gen/removeProj', projName);

                    } else if (ret.status == "InAuth") {
                        //console.log("ret.des ", ret.des);
                        newMsgDiag(MsgDiaglog, "Please Logout, then Login again.");
                    } else if (ret.status == "InData") {
                        console.log(ret.des);
                    } else if (ret.status == "InFs") {
                        newMsgDiag(MsgDiaglog, ret.des);
                    } else 
                        console.log('listProj: A err. of null of above'); 
                }
            break;
            default:
                //console.log("Misc. Err. in creating ", xhr);
                //callback("Misc. Err. in creating ");
        }
      })
      .catch(function (err) {
        newMsgDiag(MsgDiaglog, '** Server Err. at delProj: please contact Administrator; ' + err);
      });

    },
    
  } 
}
</script>
